package com.gxzc.zen.umps

import com.baomidou.kisso.SSOAuthorization
import com.baomidou.kisso.security.token.SSOToken
import com.gxzc.zen.api.sys.service.ISysPermissionService
import com.gxzc.zen.common.util.PlatformUtil
import com.gxzc.zen.common.util.SpringContextHolder
import com.gxzc.zen.umps.util.PermissionUtil
import org.apache.commons.lang3.StringUtils
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.cache.CacheManager
import org.springframework.stereotype.Component

@Component
class KissoAuthorization : SSOAuthorization {

    @Autowired
    private lateinit var cacheManager: CacheManager

    private val permissionService = SpringContextHolder.getBean(ISysPermissionService::class.java)

    override fun isPermitted(token: SSOToken?, permission: String?): Boolean {
        if (token == null) {
            return false
        }
        if (!StringUtils.isNumeric(token.id)) {
            return false
        }
        val realPerm = "${PlatformUtil.getPlatformId()}:$permission"
        return PermissionUtil.isPermitted(realPerm, permissionService.getPermissionSetByUserId(token.id.toLong()))
    }
}
